#include <stdint.h>
#include <stdio.h>
#include <string.h>

uint8_t crc8(uint8_t* data, uint8_t length) {
    uint8_t crc = 0;
    while (length--) {
        crc ^= *data++;
        for (uint8_t i = 0; i < 8; i++) {
            if (crc & 0x80) {
                crc = (uint8_t)(crc << 1) ^ 0x2F;
            } else {
                crc <<= 1;
            }
        }
    }
    return crc;
}


void main(int argc, char *argv[]) {
    uint8_t* text = "123456789";
    uint8_t crc = crc8(text, strlen(text));
    printf("Hello 0x%02X\n", crc);
}
